; BasicLib v1.1
; written on PlusShell v1.0a
; by Alban Gervaise
; (Ameliored by Philippe Gervaise :p)
; last update: 10th avril 1999


        include "tios.h"    ; we only want ot use ti OS function

        xdef _ti89          ; heu...it's a ti89!
        xdef _nostub        ; don't need any kernel!!!

GT_Error       = 2124
OSDisableBreak =  956
OSEnableBreak  =  952
OSClearBreak   =  948
ST_folder      =  912


_DEREF macro                ; so must write deref MACRO
 lsl.w #2,\1
 GET_REL_RAM_DWORD $2f,$104+$16,\2
 move.l 0(\2,\1.w),\2
 endm

GET_REL_RAM_DWORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.l \2(a5),\3
 endm

_begin                         ; same hearder as asm prog
        bra _main              ; address to main
        cnop 0,4
        dc.b "68kP"
        dc.w 0
        dc.w _comment-_begin
        dc.w _main-_begin
        dc.w 0,3,0,0,0,0,0,0,0,0,0,0

max_func                        ; _begin+38
        dc.w 027                ; number of the last function

exec_table                      ; table of the functions:                               
        dc.l sprite_str         ; dc.l  adress of the string
        bra.l put_sprite        ; bra.l adress of the function
        dc.l verti_str
        bra.l verti              ; first fast function...
        dc.l horiz_str
        bra.l horiz
        dc.l pixel_str
        bra.l pixel
        dc.l fill_str
        bra.l fill
        dc.l ST_showHelp_str
        bra.l show_help
        dc.l ST_eraseHelp_str
        bra.l erase_help
        dc.l writestr_str
        bra.l writestr
        dc.l clr_scr_str
        bra.l clr_scr
        dc.l save_scr_str
        bra.l save_scr
        dc.l rcl_scr_str
        bra.l rcl_scr
        dc.l rcl_st_line_str
        bra.l rcl_st_line
        dc.l setfont_str
        bra.l setfont
        dc.l contrast_str
        bra.l contrast
        dc.l version_str     
        bra.l version        
        dc.l st_busy_str
        bra.l st_busy
        dc.l idle_loop_str
        bra.l idle_loop
        dc.l apd_str
        bra.l apd
        dc.l rst_apd_str
        bra.l rst_apd
        dc.l getfolder_str
        bra.l getfolder
        dc.l getfile_str
        bra.l getfile
        dc.l getsize_str
        bra.l getsize
        dc.l hide_str
        bra.l hide
        dc.l unhide_str
        bra.l unhide
        dc.l off_str
        bra.l calcoff
        dc.l break_str
        bra.l break
        dc.l st_folder_str
        bra.l st_folder
        dc.l error_str
        bra.l error

; 1 version function

version_str      dc.b "Version",0      ; func 000

; 10 user functions

setfont_str      dc.b "SetFont",0      ; func 001
off_str          dc.b "Off",0          ; func 002
contrast_str     dc.b "Contrast",0     ; func 003
ST_showHelp_str  dc.b "ST_showHelp",0  ; func 004
ST_eraseHelp_str dc.b "ST_eraseHelp",0 ; func 005
st_busy_str      dc.b "ST_busy",0      ; func 006
writestr_str     dc.b "WriteStr",0     ; func 007
idle_loop_str    dc.b "Idle_loop",0    ; func 008
apd_str          dc.b "SetApd",0       ; func 009
rst_apd_str      dc.b "RstApd",0       ; func 010

; 5 file functions

getfolder_str    dc.b "GetFolder",0    ; func 011 
getfile_str      dc.b "GetFile",0      ; func 012
getsize_str      dc.b "GetSize",0      ; func 013
hide_str         dc.b "Hide",0         ; func 014
unhide_str       dc.b "unHide",0       ; func 015

; 9 graphic functions

clr_scr_str      dc.b "Clr_scr",0      ; func 016
save_scr_str     dc.b "Save_scr",0     ; func 017
rcl_scr_str      dc.b "Rcl_scr",0      ; func 018
rcl_st_line_str  dc.b "Rcl_ST_Line",0  ; func 019
verti_str        dc.b "Verti",0        ; func 020
horiz_str        dc.b "Horiz",0        ; func 021
pixel_str        dc.b "Pixel",0        ; func 022
fill_str         dc.b "Fill",0         ; func 023
sprite_str       dc.b "Sprite",0       ; func 024

; new functions...

break_str        dc.b "Break",0        ; func 025
st_folder_str    dc.b "ST_folder",0    ; func 026
error_str        dc.b "Error",0        ; func 027


_main   lea.l var_name(pc),a0          ; first: search "b_l"
        bsr search_bis
        tst.w d0                       ; d0=0=> no "b_l"
        beq.b \cont
        pea.l nofound(pc)
        bra.b disp
\cont   move.l a0,vat                  ; d0!=0=> a0=adress of the vat of "b_l"
        move.w 12(a0),d0
        _DEREF d0,a0
        lea 3(a0),a0
        move.l a0,addr
        move.l #2000,-(a7)             ; check if have 2000 bytes...
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        tst.w d0
        bne.b ok
mem     pea.l memory(pc)
disp    ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
        rts                            ; no so leave...
ok      move.w d0,handle
        _DEREF d0,a1
        move.l a1,str                  ; yes so put the adress of the memory in str
restart move.l addr,a0
        move.l str,a1

\loop   tst.b (a0)
        beq.s \bon                     ; prepare the id string
        cmp.b #58,(a0)
        beq.s \bon
        cmp.b #124,(a0)
        beq.s \bon
        move.b (a0)+,(a1)+
        bra.b \loop  
\bon    clr.b (a1)
        lea.l exec_table(pc),a0
        move.w max_func,d7

\loopd7 movem.l a0/d7,-(a7)           ; main loop
        move.l (a0),d0
        lea.l _begin(pc),a0
        add.l d0,a0
        move.l a0,-(a7)
        move.l str,-(a7)
        ROM_CALL romfunc::strcmp       ; check if function string exists
        lea 8(a7),a7
        movem.l (a7)+,a0/d7
        tst.w d0
        beq lance                      ; yes so launch it
        lea.l 8(a0),a0
        dbra.s d7,\loopd7
        bra exit
lance   jmp 4(a0)                      ; jmp to the adress


;-----------------------------------------------------------------------------
; fonction 000: VERSION
;
; retourne la version de BasicLib (ici v1.1)
; return the version of BasicLib (here v1.1)
;-----------------------------------------------------------------------------

version lea.l _comment(pc),a0
        move.l str,a1
\loop   move.b (a0),(a1)+
        tst.b (a0)+
        bne.s \loop
        bra make_string


;-----------------------------------------------------------------------------
; fonction 001: SETFONT
;
; charge une fonte
; load a new font
;-----------------------------------------------------------------------------

setfont move.l addr,a0
        clr.w d0
        move.b 8(a0),d0
        sub.w #48,d0
        cmp.w #2,d0
        bgt exit
        move.w d0,-(a7)
        ROM_CALL romfunc::FontSetSys
        lea 2(a7),a7
        bra good

;-----------------------------------------------------------------------------
; fonction 002: OFF
;
; eteint la ti89
; turn off ti89
;-----------------------------------------------------------------------------

calcoff trap #4
        bra good

;-----------------------------------------------------------------------------
; fonction 003: CONTRAST
;
; augment ou diminue le contrast
; increase or decrease the contrast
;-----------------------------------------------------------------------------

contrast
        move.l addr,a0
        move.b 9(a0),d0
        cmp.b #'u',d0
        bne \down
        moveq #9,d0
        bra \do_it
\down   cmp.B #'d',d0
        bne exit
        moveq #10,d0
\do_it  trap #9
        jsr (a0)
        bra good


;-----------------------------------------------------------------------------
; fonction 004: ST_SHOWHELP
;
; affiche un string dans la status line
; disp a string in the status line
;-----------------------------------------------------------------------------

show_help:
        move.l addr,a0
        lea 12(a0),a0
        bsr copy_string
        move.l str,-(a7)
        ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
        bra good


;-----------------------------------------------------------------------------
; fonction 005: ST_ERASEHELP
;
; efface le contenu de la status line
; erase the string of the status line
;-----------------------------------------------------------------------------

erase_help:
        ROM_CALL romfunc::ST_eraseHelp
        bra good


;-----------------------------------------------------------------------------
; fonction 006: ST_BUSY
;
; modifie l'etat de l'indicateur de fonctionnement
; change the sate of the status line indicator
;-----------------------------------------------------------------------------

st_busy move.l addr,a0
        clr.w d0
        move.b 8(a0),d0
        sub.w #48,d0
        cmp.w #2,d0
        bgt exit
        move.w d0,-(a7)
        ROM_CALL romfunc::ST_busy
        lea 2(a7),a7
        bra good


;-----------------------------------------------------------------------------
; fonction 007: WRITESTR
;
; affiche un string en x,y
; write a string at x,y        
;-----------------------------------------------------------------------------

writestr
        move.l addr,a0
        lea 9(a0),a0
        bsr convert_nbr
        move.w d0,-(a7)
        add.l #1,a0
        bsr convert_nbr
        move.w d0,d1
        clr.w d2
        move.B 1(a0),d2
        sub.w #48,d2
        lea 3(a0),a0
        move.w (a7)+,d0
        cmp.b #5,d2
        bge exit
        bsr copy_string
        move.w d2,-(a7)
        move.l str,-(a7)
        movem.w d1/d0,-(a7)
        ROM_CALL romfunc::DrawStrXY
        lea 10(a7),a7
        bra good


;-----------------------------------------------------------------------------
; fonction 009: IDLE_LOOP
;
; meme chose que pause: attend jsuqu'a que ESC ou ENTER soit presse
; same thing as pause: wait until ESC or ENTER is pressed
;-----------------------------------------------------------------------------

idle_loop:
        move.l $5b10,$5b14
        clr.w $5b42
\wait_idle
        tst.w $5b42
        beq.s \no_apd
\do_apd trap #4
        bra.s idle_loop
\no_apd tst.w $75Ba
        beq.s \wait_idle
        move.l $5b10,$5b14
        move.w $75bc,d0
        clr.w $75ba
\try_key_off
        cmp.w #16651,d0
        beq.s \do_apd
        cmp.w #13,d0
        beq good
        cmp.w #264,d0
        bne.s idle_loop
        bra good

;-----------------------------------------------------------------------------
; fonction 009: SET_APD
;
; modifie la valeur de l'Auto Power Down
; change the value of the Auto Power Down
;-----------------------------------------------------------------------------

apd     move.l addr,a0
        lea 7(a0),a0
        bsr convert_nbr
        cmp.w #10,d0
        blt exit
        cmp.w #600,d0
        bgt exit
        swap d0
        clr.w d0
        swap d0
        mulu #19,d0
        move.l d0,$5b10
        bra good


;-----------------------------------------------------------------------------
; fonction 010: RST_APD
;
; remet la valeur initiale de 'APD
; set to defauts the APD
;-----------------------------------------------------------------------------

rst_apd move.l #$1770,$5b10
        bra good




;-----------------------------------------------------------------------------
; fonction 011: GET_FOLDER
;
; retourne la liste des folders
; return the list of the folders
;-----------------------------------------------------------------------------

getfolder
        move.l addr,a0
        cmp.b #58,9(a0)
        bne getfolderbis
        lea 10(a0),a0

        move.l str,a2
\copy   move.b (a0),(a2)+
        tst.b (a0)+
        bne.b \copy
        move.l str,a0
        bsr search_bis
        tst.w d0
        bne exit
        move.l str,a2
\loop   move.b (a1),(a2)+
        tst.b (a1)+
        bne.b \loop
        bra make_string

getfolderbis
        moveq #8,d0
enc     _DEREF d0,a0
        move.w 2(a0),d0
        tst.w d0
        beq good
        sub.w #1,d0
        lea 4(a0),a0
        move.l str,a2
\loop   move.l a0,-(a7)
        cmp.b #97,(a0)
        blt.b \passe
        cmp.b #122,(a0)
        bgt.b \passe
\loop2  move.b (a0)+,(a2)+
        tst.b (a0)
        bne.b \loop2
        move.b #58,(a2)+
\passe  move.l (a7)+,a0
        lea 14(a0),a0
        dbra.b d0,\loop
        clr.b -(a2)
        bra make_string


;-----------------------------------------------------------------------------
; fonction 012: GET_FILE
;
; retourne la liste des fichiers d'un repertoire
; return the list of all files of a special folder
;-----------------------------------------------------------------------------

getfile move.l addr,a1
        lea 8(a1),a1
        moveq #8,d0
        _DEREF d0,a0
        move.w 2(a0),d7
        sub.w #1,d7
        lea 4(a0),a0
\loopd7 cmp.b #97,(a0)
        blt.b \passe
        cmp.b #122,(a0)
        bgt.b \passe
        movem.l a0-a1,-(a7)
        movem.l a0-a1,-(a7)
        ROM_CALL romfunc::strcmp
        lea 8(a7),a7
        movem.l (a7)+,a0-a1
        tst.w d0
        beq.b \bon
\passe  lea 14(a0),a0
        dbra.b d7,\loopd7
        bra exit
\bon    move.w 12(a0),d0
        bra enc


;-----------------------------------------------------------------------------
; fonction 013: GET_SIZE
;
; retourne la taille d'un fichier
; return the size of a file
;-----------------------------------------------------------------------------

getsize move.l addr,a0
        lea 8(a0),a0
        bsr search_bis
        tst.w d0
        bne exit
        move.w 12(a0),d0
        _DEREF d0,a0
        move.w (a0),d0
        add.w #2,d0

convert_string:
        move.l str,a0
        lea 5(a0),a0
        clr.b (a0)
        moveq #4,d1
print_loop:
        divu #10,d0
        swap d0
        add.b #48,d0
        move.b d0,-(a0)
        clr.w d0
        swap d0
        dbra.b d1,print_loop
        bra make_string


;-----------------------------------------------------------------------------
; fonction 014: HIDE
;
; cache la variable du TIOS
; hide the var from tios
;-----------------------------------------------------------------------------

hide    move.l addr,a0
        lea 5(a0),a0
        bsr search_bis
        tst.w d0
        bne exit
        cmp.l vat,a0     ; si c'est a alors nonnnn! (d'ailleurs je peux rien pour Basic :(
        beq exit         ;
        bset.b #4,11(a0)
        bra good


;-----------------------------------------------------------------------------
; fonction 015: UNHIDE
;
; annule les effets de HIDE
; clear the effects of HIDE
;-----------------------------------------------------------------------------

unhide  move.l addr,a0
        lea 7(a0),a0
        bsr search_bis
        tst.w d0
        bne exit
        bclr.b #4,11(a0)
        bra good


;-----------------------------------------------------------------------------
; fonction 016: CLR_SCR
;
; efface tout l'ecran
; clear the screen
;-----------------------------------------------------------------------------

clr_scr movea #$4c00,a0
        move.w #749,d0
\clear  clr.l (a0)+
        dbra.s d0,\clear
        bra good


;-----------------------------------------------------------------------------
; fonction 017: SAVE_SCR
;
; sauve l'ecran en tant que PIC
; save the screen so return a PIC
;-----------------------------------------------------------------------------
        
save_scr
        move.l #3847-840,-(a7)
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        tst.w d0
        beq mem
        move.w d0,d7
        move.l vat,a0
        move.w 12(a0),-(a7)
        move.w d7,12(a0)
        ROM_CALL romfunc::HeapFree ; on libere l'ancienne handle
        lea 2(a7),a7
        _DEREF d7,a0
        move.w #3845-840,(a0)+
        move.w #100,(a0)+
        move.w #240,(a0)+
        movea #$4c00,a1
        move.w #749,d0
\copy   move.l (a1)+,(a0)+
        dbra.b d0,\copy
        move.b #$DF,(a0)
        bra clr_str


;-----------------------------------------------------------------------------
; fonction 018: RCL_SCR
;
; restore l'ecran
;-----------------------------------------------------------------------------

rcl_scr move.l addr,a0
        lea 8(a0),a0
        bsr search_bis
        tst.w d0
        bne exit
        move.w 12(a0),d0
        _DEREF d0,a0
        cmp.l #$0BBD0064,(a0)
        bne exit
        lea 6(a0),a0
        movea #$4c00,a1
        move.w #749,d0
\copy   move.l (a0)+,(a1)+
        dbra.b d0,\copy
        bra good


;-----------------------------------------------------------------------------
; fonction 019: RCL_ST_LINE
;
; redessine la status line
; redraw the status line
;-----------------------------------------------------------------------------

rcl_st_line
        movea #$4c00+93*30,a0
        moveq #2,d2
draw_line
        moveq #4,d0
\loop1  tst.b d2
        beq \invert
        cmp.b #1,d2
        beq \white
        move.l #$FFFFFFFF,(a0)+
        dbra.b d0,\loop1
        bra good
\white  clr.l (a0)+
        dbra.b d0,\loop1
        bra good
\invert not.l (a0)+
        dbra.b d0,\loop1
        bra good


;-----------------------------------------------------------------------------
; fonction 020: VERTI
;
; dessine une ligne verticale
; draw a vertical line
;-----------------------------------------------------------------------------

verti   move.l addr,a0
        lea 6(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d3    ; d3=X
        lea.l 1(a0),a0
        bsr convert_nbr
        cmp.w #100,d0
        bge exit
        move.w d0,d4    ; d4=Y1
        lea.l 1(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d5    ; d5=Y2
        cmp.w d4,d5
        ble exit
        move.b 1(a0),d2
        sub.b #48,d2
        move.w d4,d1
        sub.w d4,d5
        move.w d3,d0
\loop   movem.w d0-d2,-(a7)
        bsr pxl_do
        movem.w (a7)+,d0-d2
        add.w #1,d1
        dbra.s d5,\loop
        bra good


;-----------------------------------------------------------------------------
; fonction 021: HORIZ
;
; dessine une ligne verticale
; draw a horizontal line
;-----------------------------------------------------------------------------

horiz   move.l addr,a0
        lea 6(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d3
        addq.l #1,a0
        bsr convert_nbr
        cmp.w #100,d0
        bge exit
        move.w d0,d4
        addq.l #1,a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d5
        move.b 1(a0),d2
        sub.b #48,d2
        move.w d4,d1
        move.w d3,d0
        sub.w d3,d5
\loop   movem.w d0-d2,-(a7)
        bsr pxl_do
        movem.w (a7)+,d0-d2
        add.w #1,d0
        dbra.s d5,\loop
        bra good


;-----------------------------------------------------------------------------
; fonction 022: PIXEL
;
; dessine un pixel sur l'ecran
; draw a pixel
;-----------------------------------------------------------------------------

pixel   move.l addr,a0
        lea 6(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d3        ; d3=X
        add.l #1,a0
        bsr convert_nbr
        cmp.w #100,d0
        bge exit
        exg d1,d0
        move.b 1(a0),d2
        sub.b #48,d2
        move.w d3,d0
        bsr pxl_do
        bra good


;-----------------------------------------------------------------------------
; fonction 023: FILL
;
; dessine un rectangle rempli
; fill a rect
;-----------------------------------------------------------------------------

fill    move.l addr,a0
        lea.l 5(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d2
        lea 1(a0),a0
        bsr convert_nbr
        cmp.w #100,d0
        bge exit
        move.w d0,d3
        lea 1(a0),a0
        bsr convert_nbr
        cmp.w #160,d0
        bge exit
        move.w d0,d4
        lea 1(a0),a0
        bsr convert_nbr
        cmp.w #100,d0
        bge exit
        move.w d0,d5  ; X1=d2 / Y1=d3 / X2=d4 / Y2=d5 / countX=d6 /countY=d7
        move.b 1(a0),d0
        sub.b #48,d0
        move.b d0,taille
        cmp.w d3,d5
        blt exit
        cmp.w d2,d4
        blt exit
        move.w d5,d7
        sub.w d3,d7
        move.w d3,d1
\loopd7 move.w d2,d0
        move.w d4,d6
        sub.w d2,d6
\loopd6 movem.w d0-d2,-(a7)
        move.b taille,d2
        bsr pxl_do
        movem.w (a7)+,d0-d2
        add.w #1,d0
        dbra.s d6,\loopd6
        add.w #1,d1
        dbra.s d7,\loopd7
        bra good


;-----------------------------------------------------------------------------
; fonction 024: PUT_SPRITE
;
; affiche un sprite
; displays a sprite
; Parameter : 4
;   File (string)
;   X (0-??)
;   Y (0-??)
;   Copy Mode (0-3)
;
;-----------------------------------------------------------------------------

put_sprite:
	move.w #3,d0                ;Choose parameter n3
	bsr GetParam                ;Get parameter n3
	cmp.l #0,a0                 ;Parameter exist ?
	beq exit                    ;No -> Exit

	move.l addr,a0              ;Get address to function
	lea.l 7(a0),a0              ;Skip function name + 1 (len(SPRITE) = 6)
	bsr search_bis              ;Search the file
	tst.w d0                    ;File found (d0 = 0) ?
	bne exit                    ;No -> Exit with error
	move.w 12(a0),d0            ;Yes -> Retrieve file handle
	_DEREF d0,a5                ;Get file address
	lea.l 2(a5),a5              ;Skip file size

	move.w #2,d0                ;Choose parameter 2
	bsr GetParam                ;Get parameter 2
	bsr convert_nbr             ;Convert parameter 2 into a number
	move.w d0,SpriteX           ;Save parameter 2 into SpriteX

	move.w #3,d0                ;Choose parameter 3
	bsr GetParam                ;Get parameter 3
	bsr convert_nbr             ;Convert Parameter 3 into a number
	move.w d0,SpriteY           ;Save parameter 3 into SpriteY

	move.w #4,d0                ;Choose parameter 4
	bsr GetParam                ;Get parameter 4
	cmp.l #0,a0                 ;Parameter exist ??
	beq NoMode                  ;Yes -> Skip mode retrieve

	bsr convert_nbr             ;Convert parameter 4 into a number
	move.w d0,d1                ;Save parameter 4 into d1

NoMode:
	and.b #1,d0                 ;Invert mode ?
	move.b d0,Invert            ;Put mode (0 or 1) in Invert
	lsr.b #1,d1                 ;Get Recover Mode (0 or 1)
	move.b d1,Recover           ;Put recover mode in Recover

	move.l a5,a2
	move.w SpriteX,d0
	move.l #$4c00,a0            ;Get the LCD Memory

	move.w SpriteY,d1           ;Put SpriteY in D1
	mulu #30,d1                 ;Multiply SpriteY by 30
	add.w d1,a0                 ;Go the wanted Y on the screen
	move.w d0,d1                ;
	andi.b #7,d1                ;Get the bit number
	move.w #7,d5                ;
	sub.w d1,d5                 ;d5 = 7 - x mod 8
	move.b #%00000001,d4        ;Start with this mask for the LCD
	lsl.b d5,d4                 ;d4 -> Mask for current bit, for the LCD
	lsr.w #3,d0                 ;
	add.w d0,a0                 ;Go to the wanted X on the screen
	move.w (a2)+,d1             ;Vertical size (in pixels)
	move.w (a2)+,d0             ;Horizontal size (in pixels)
	sub.w #1,d1
	sub.w #1,d0 
	move.w d1,d7
	move.l a0,-(a7)             ;Save LCD memory position
	move.b d4,-(a7)             ;Save LCD Mask
NextSpriteLine:
	move.b #%10000000,d5        ;Mask for the sprite
	move.w d0,d6
NextSpriteBit:
        cmp.l #$4c00+3000,a0      ;On the screen ?
	bhi SpriteEnd               ;If out, quit
	move.b (a2),d2              ;Get byte from sprite data
	tst.w Invert                ;Test if invert mode is set
	beq NoInvert
	not.b d2                    ;If set, negate sprite data
NoInvert:
	and.b d5,d2                 ;Apply mask, d2 is the bit to change
	tst.b d2                    ;is there a bit in d2 ?
	beq NoPixel
	or.b d4,(a0)                ;Set a bit on the screen
	bra PixelWrited
NoPixel tst.w Recover               ;Test if recover mode is set
	beq PixelWrited             ;If not set skip writing an white pixel (0)
	not.b d4                    ;Negate the LCD mask
	and.b d4,(a0)               ;Write a white pixel (0)
	not.b d4                    ;Restore the LCD mask
PixelWrited:
	lsr.b #1,d4                 ;Mask for next bit
	tst.b d4                    ;Next byte for LCD ? (if mask = 0)
	bne NoLCDAdjust             ;if yes adjust LCD memory
	move.b #%10000000,d4        ;New mask for the LCD memory
	addq #1,a0                  :Next byte
NoLCDAdjust:
	lsr.b #1,d5                 ;Mask for next bit
	tst.b d5                    ;Next byte for sprite ? (if mask = 0)
	bne NoSpriteAdjust
	tst.b d6                    ;Last bit of the current line ?
	beq NoSpriteAdjust          ;If yes, do not go to the next data
	move.b #%10000000,d5        ;New mask for the sprite
	addq #1,a2                  ;Next sprite data
NoSpriteAdjust:
	dbra.w d6,NextSpriteBit
	addq #1,a2                  ;If no, go to the next sprite data
	move.b (a7)+,d4             ;Restore LCD mask (for new line)
	move.l (a7)+,a0             ;Restore LCD memory position
	add.l #30,a0                ;Next line
	move.l a0,-(a7)             ;Save LCD memory position
	move.b d4,-(a7)             ;Save LCD Mask
	dbra.w d7,NextSpriteLine
SpriteEnd:
	move.b (a7)+,d4             ;Restore LCD mask (flush stack)
	move.l (a7)+,a0             ;Restore LCD memory position (flush stack)
	bra good


;-----------------------------------------------------------------------------
; fonction 025: BREAK
;
; gere la fonction break
; manage the break function
;-----------------------------------------------------------------------------

break   move.l addr,a0
        lea 6(a0),a0
        cmp.b #48,(a0)
        beq \enable
        cmp.b #49,(a0)
        beq \disable
        ROM_CALL OSClearBreak/4
        bra good
\enable ROM_CALL OSEnableBreak/4
        bra good
\disable ROM_CALL OSDisableBreak/4
        bra good

;-----------------------------------------------------------------------------
; fonction 026: ST_FOLDER
;
; affiche en permanence le nom du folder voulu
; disp the chosen folder
;-----------------------------------------------------------------------------

st_folder move.l addr,a0
        lea 10(a0),a0
        move.l str,a1
        move.w #11,d0
\copy   move.b (a0)+,(a1)+
        cmp.B #124,(a0)
        beq.s \ok
        tst.b (a0)
        beq.s \ok
        dbra.s d0,\copy
\ok     clr.b (a1)
        move.l str,-(a7)
        ROM_CALL ST_folder/4
        lea 4(a7),a7
        bra good


;-----------------------------------------------------------------------------
; fonction 027: ERROR
;
; affiche un message d'erreur
; disp an error message
;-----------------------------------------------------------------------------

error   move.l addr,a0
        lea 6(a0),a0
        bsr convert_nbr
        move.w d0,-(a7)
        ROM_CALL GT_Error/4
        lea 2(a7),a7
        bra good
        
;-----------------------------------------------------------------------------
; fonctions auxiliaires: (other functions...)
;
; GetParam   : Get parameter number d0
; copy_string: copie un string en le coupant apres un 124 ou un 0
; pxl_do     : affiche un pixel
; convert_nbr: converti un nombre sous forme de string en un nombre mis dans d0
; make_string: cree un list avec les string contenus dans str
; search_bis : cherche une variable avec son nom et son folder
;-----------------------------------------------------------------------------

;===============================================================================
;Any comment, mail to candyman@i-france
;Input : 
;	addr    : Address of current function (Variable)
;	dc.w d0 : Get parameter nb d0 (0-n), 0 is the function name
;Output :
;	dc.l a0 : Address of current parameter (a0 = 0 on error)
;
;Registers destroyed :
;	d1, d2, a0
;===============================================================================
GetParam:
	move.l addr,a0              ;Get parameter string
	tst.w d0                    ;Get parameter number 0 ?
	beq ParamOK                 ;If yes, a0 is good

SearchParam1:
	cmp.b #':',(a0)+            ;End of function name ?
	bne SearchParam1            ;if no -> Scan next character

;Now a0 is a pointer to the first parameter

	move.w #1,d2                ;Current Parameter (first)

ScanParam:
	cmp.w d0,d2                 ;Current parameter is the one required ?
	beq ParamOK                 ;if yes, exit

	add.w #1,d2                 ;Go to next parameter

GoToNextParam:
	move.b (a0)+,d1             ;Retrieve current character

	tst.b d1                    ;End of string ?
	beq ParamError              ;If yes -> Error !!

	cmp.b #'|',d1               ;No more parameters ?
	beq ParamError              ;If yes -> Error !!

	cmp.b #',',d1               ;End of current parameter ?
	bne GoToNextParam           ;If no continue scanning string

	bra ScanParam               ;Next parameter

ParamError:
	move.l #0,a0                ;Error -> Set string address to 0

ParamOK:
	rts

;===============================================================================
;===============================================================================


copy_string:
        move.l str,a1
\loop   move.b (a0),(a1)+
        tst.b (a0)+
        beq.s \bon
        cmp.b #124,(a0)
        bne.s \loop
\bon    clr.b (a1)
        rts


pxl_do  movea #$4c00,a0
        lsl.w #1,d1              ; d2=0:pixel_on (d0.w=x d1.w=y)
        move.w d1,d3             ; d2=1:pixel_off (d0.w=x d1.w=y)
        lsl.w #4,d1              ; d2=2:pixel_chg (d0.w=x d1.w=y)
        sub.w d3,d1
        lea 0(a0,d1.w),a0
        move.w d0,d3
        lsr.w #3,d0
        not.w d3
        and.w #7,d3
        tst.b d2
        beq.b \chg
        cmp.w #1,d2
        beq.b \clr
        bset.b d3,0(a0,d0.w)
        rts
\clr    bclr.b d3,0(a0,d0.w)
        rts
\chg    bchg.b d3,0(a0,d0.w)
        rts


convert_nbr:            ; input: a0.l = adresse ou se trouve le string a convertir) / output: d0.w = nombre
        move.l a0,a1
        clr.w d1
\loopn  add.w #1,d1
        add.l #1,a1
        tst.b (a1)
        beq.s \begin
        cmp.b #',',(a1)
        beq.s \begin
        cmp.b #124,(a1)
        bne.s \loopn
\begin  sub.w #1,d1
        clr.w d0
\loop   mulu #10,d0
        add.b (a0)+,d0
        sub.w #48,d0
        dbra.s d1,\loop
        rts

make_string:
        move.l vat,a0
        move.w 12(a0),-(a7)
        ROM_CALL romfunc::HeapFree  ; on libere l'ancienne handle
        lea 2(a7),a7
        move.l str,-(a7)
        ROM_CALL romfunc::strlen    ; on veut la taille de str
        lea 4(a7),a7
        move.w d0,taille

        move.l str,a0
\loop   tst.b (a0)
        beq \bon
        cmp.b #':',(a0)+
        bne.S \loop
        add.w #2,taille
        bra.S \loop
\bon    clr.l d0
        move.w taille,d0
        add.l #7,d0
        move.l d0,-(a7)
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        move.l vat,a0
        move.w d0,12(a0)
        _DEREF d0,a0
        move.w taille,d0
        move.w d0,(a0)
        add.w #5,(a0)+
        move.w #$e500,(a0)+
        move.l str,a2
\copy   tst.b (a2)
        beq.b \fin
        cmp.b #':',(a2)
        beq.b \chg
        move.b (a2)+,(a0)+
        bra.b \copy
\chg    clr.B (a0)+
        move.b #45,(a0)+
        clr.b (a0)+
        add.l #1,a2
        bra.b \copy
\fin    clr.b (a0)+
        move.b #45,(a0)+
        move.b #217,(a0)

clr_str move.w handle,-(a7)
        ROM_CALL romfunc::HeapFree
        lea 2(a7),a7
        rts

; SEARCH BIS
; fonction: cherche l'adresse d'une variable a partir de son nom et de son folder
; Ex : 'main\tst', if it's only 'tst' (then there isn't have any '\') execute search
; input  : a0 = adresse du nom
; output : a0 = adresse de la vat

search_bis
        movem.l a2-a6/d1-d7,-(a7)
	move.l a0,a1                ;Save string address into a1
	lea FolderName(PC),a3       ;Get FolderName address in a3
\mode
	move.b (a1)+,(a3)           ;Copy char from Input to FolderName
	tst.b (a3)                  ;End of string ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #',',(a3)             ;End of parameter ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #'|',(a3)             ;End of function ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #'\',(a3)             ;Found '\' ??
	beq DirMode                 ;If yes, retrieve filename

	addq #1,a3                  ;'\' not found, next char
	bra \mode                   ;'\' not found, -> Copy next char

FileMode:
	move.b #0,(a3)              ;Put a end of string to FolderName
	lea FolderName(PC),a3       ;Get FolderName address in a3
	lea FileName(PC),a4         ;Get FileName address in a4
\strcpy
	move.b (a3),(a4)+           ;Copy FolderName into FileName
	tst.b (a3)+                 ;End of string for FolderName ?
	bne \strcpy                 ;No -> Continue copying

	move.w #1,taille            ;Engage file mode (No folder)
	bra endcopy2                ;Now, search file

DirMode:
	move.b #0,(a3)              ;Put a end of string to FolderName
	move.w #0,taille            ;Engage Folder mode (Folder present)
	lea FileName(PC),a3         ;Get FileName address in a3

\copy2
	move.b (a1)+,(a3)           ;Copy filename to variable FileName

	cmp.b #',',(a3)             ;End of parameter ?
	beq EndFileCopy             ;Yes -> Terminate copy

	cmp.b #'|',(a3)             ;End of function ?
	beq EndFileCopy             ;Yes -> Terminate copy

	tst.b (a3)                  ;End of string ?
	beq endcopy2                ;If yes, stop copy

	addq #1,a3                  ;Next char
	bra \copy2                  ;Copy next character

EndFileCopy:
	move.b #0,(a3)              ;Put a end of string in FileName

endcopy2
	moveq #8,d1                 ;Get folder list handle
	_DEREF d1,a1                ;a1 -> pointer to Folder list
	move.w 2(a1),d1             ;Get number of folders
	sub.w #1,d1
	lea 4(a1),a1                ;Go to first folder description (name)
NextFolder
	tst.w taille                ;File Mode ?
	bne \apres                  ;<> 0 -> File Mode engage -> Check files in this folder

	movem.l a0-a6/d1-d7,-(a7)
	move.l a1,-(a7)
	pea FolderName(PC)
	ROM_CALL romfunc::strcmp
	lea 8(a7),a7
	movem.l (a7)+,a0-a6/d1-d7
	tst.w d0
	beq \apres
	lea 14(a1),a1
	dbra.s d1,NextFolder
	beq fini2

\apres
	move.w 12(a1),d0            ;Get Current folder Handle
	_DEREF d0,a0                ;Get pointer to file list
	move.w 2(a0),d7             ;Get number of files
	tst.w d7                    ;Is there any files ?
	beq SkipFolder              ;No -> Skip this folder

	sub.w #1,d7
	lea 4(a0),a0                ;Go to the first file descriptor (name)
NextFile:
	movem.l a0-a6/d1-d6,-(a7)
	movem.l a0,-(a7)
	pea FileName(PC)
	ROM_CALL romfunc::strcmp
	lea 8(a7),a7
	movem.l (a7)+,a0-a6/d1-d6

	tst.w d0                    ;File found ?
	beq fini2                   ;Yes -> End of routine
	lea 14(a0),a0               ;No -> Go to the next file descriptor
	dbra.s d7,NextFile          ;Is there again some files ?

SkipFolder:
	lea 14(a1),a1               ;Go to the next folder descriptor
	dbra d1,NextFolder          ;Is there again some folders ?
fini2:
        movem.l (a7)+,a2-a6/d1-d7
	rts

;-----------------------------------------------------------------------------
; fonctions de sortie:
;
;exit (une erreur s'est produite): retourne un "0" dans b_l
;good (la foncion a ete executee): retourne un "1" dans b_l
;-----------------------------------------------------------------------------

exit    move.l str,a0
        move.B #'0',(a0)+
do_mv   clr.b (a0)
        bra make_string                ; on fait une list avec "0"
good    ROM_CALL OSClearBreak/4        ; si ON a t press alors pas break
        move.l str,a0
        move.b #'1',(a0)+
        move.l addr,a1
\loop   tst.b (a1)
        beq.b do_mv
        cmp.b #124,(a1)+               ; si on trouve | alors il y a une autre fonction
        bne.s \loop
        move.l a1,addr
        bra restart

taille           dc.w 0

SpriteX	dc.w 0
SpriteY	dc.w 0
Invert  dc.w 0       ;0 = Normal, 1 = Invert
Recover dc.w 0       ;0 = Normal, 1 = Recover

FolderName		dc.b "philippe",0,0
FileName		dc.b "gervaise",0,0

var_name         dc.b "b_l",0
memory           dc.b "not enough memory",0
nofound          dc.b "can't find b_l",0

addr             dc.l 0    ; adresse du fichier d b_l
vat              dc.l 0    ; adresse de la vat de b_l
str              dc.l 0    ; adresse de str
handle           dc.w 0    ; handle de str

_comment         dc.b "by Alban Gervaise:v1.0:BasicLib",0


; each ":" means that it is a element in a list

 end  ; finish...wooh c'est plutot coool ce programme! (je sais je suis gnial...)


; made by Alban Gervaise
; you can take some lines in your program
; (please don't change the name of the author!)



; (petit message perso: bonne chance  tout ceux qui passe le BAC (francais ou
;gneral comme moi) en juin... mais aussi ceux qui passe des concours (c'est
;encore mon cas, c'est pourquoi je suis tres occupe en ce moment), bonne chance
;donc...et surtout bon courage!!!)

;Ouahhh l'autre !!! Tant qu'a faire alors, j'y met mon grain de sel !
;Donc un gros big up a l'EPITA, na !

